diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.43/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.42/src/wifi/test/spectrum-wifi-phy-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/spectrum-wifi-phy-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -803,6 +786,799 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
+ * \brief Spectrum Wifi Phy Bands Calculations Test
+ *
+ * This test verifies SpectrumWifiPhy::GetBand produces the expected results, for both contiguous
+ * (160 MHz) and non-contiguous (80+80MHz) operating channel
+ */
+class SpectrumWifiPhyGetBandTest : public TestCase
+{
+  public:
+    SpectrumWifiPhyGetBandTest();
+
+  private:
+    void DoSetup() override;
+    void DoTeardown() override;
+    void DoRun() override;
+
+    /**
+     * Run one function
+     * \param channelNumberPerSegment the channel number for each segment of the operating channel
+     * \param bandWidth the width of the band to test
+     * \param bandIndex the index of the band to test
+     * \param expectedIndices the expected start and stop indices returned by
+     * SpectrumWifiPhy::GetBand \param expectedFrequencies the expected start and stop frequencies
+     * returned by SpectrumWifiPhy::GetBand
+     */
+    void RunOne(const std::vector<uint8_t>& channelNumberPerSegment,
+                MHz_u bandWidth,
+                uint8_t bandIndex,
+                const std::vector<WifiSpectrumBandIndices>& expectedIndices,
+                const std::vector<WifiSpectrumBandFrequencies>& expectedFrequencies);
+
+    Ptr<SpectrumWifiPhy> m_phy; ///< PHY
+};
+
+SpectrumWifiPhyGetBandTest::SpectrumWifiPhyGetBandTest()
+    : TestCase("SpectrumWifiPhy test bands calculations")
+{
+}
+
+void
+SpectrumWifiPhyGetBandTest::DoSetup()
+{
+    // WifiHelper::EnableLogComponents();
+    // LogComponentEnable("SpectrumWifiPhyTest", LOG_LEVEL_ALL);
+
+    auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+    auto lossModel = CreateObject<FriisPropagationLossModel>();
+    lossModel->SetFrequency(5.180e9);
+    spectrumChannel->AddPropagationLossModel(lossModel);
+    auto delayModel = CreateObject<ConstantSpeedPropagationDelayModel>();
+    spectrumChannel->SetPropagationDelayModel(delayModel);
+
+    auto node = CreateObject<Node>();
+    auto dev = CreateObject<WifiNetDevice>();
+    m_phy = CreateObject<SpectrumWifiPhy>();
+    auto interferenceHelper = CreateObject<InterferenceHelper>();
+    m_phy->SetInterferenceHelper(interferenceHelper);
+    auto errorModel = CreateObject<NistErrorRateModel>();
+    m_phy->SetErrorRateModel(errorModel);
+    m_phy->SetDevice(dev);
+    m_phy->AddChannel(spectrumChannel);
+    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
+    dev->SetPhy(m_phy);
+    node->AddDevice(dev);
+}
+
+void
+SpectrumWifiPhyGetBandTest::DoTeardown()
+{
+    m_phy->Dispose();
+    m_phy = nullptr;
+}
+
+void
+SpectrumWifiPhyGetBandTest::RunOne(
+    const std::vector<uint8_t>& channelNumberPerSegment,
+    MHz_u bandWidth,
+    uint8_t bandIndex,
+    const std::vector<WifiSpectrumBandIndices>& expectedIndices,
+    const std::vector<WifiSpectrumBandFrequencies>& expectedFrequencies)
+{
+    WifiPhy::ChannelSegments channelSegments;
+    for (auto channelNumber : channelNumberPerSegment)
+    {
+        const auto& channelInfo = WifiPhyOperatingChannel::FindFirst(channelNumber,
+                                                                     0,
+                                                                     0,
+                                                                     WIFI_STANDARD_80211ax,
+                                                                     WIFI_PHY_BAND_5GHZ);
+        channelSegments.emplace_back(channelInfo->number, channelInfo->width, channelInfo->band, 0);
+    }
+    m_phy->SetOperatingChannel(channelSegments);
+
+    const auto& bandInfo = m_phy->GetBand(bandWidth, bandIndex);
+    NS_ASSERT(expectedIndices.size() == expectedFrequencies.size());
+    NS_ASSERT(expectedIndices.size() == bandInfo.indices.size());
+    NS_ASSERT(expectedFrequencies.size() == bandInfo.frequencies.size());
+    for (std::size_t i = 0; i < expectedIndices.size(); ++i)
+    {
+        NS_ASSERT(bandInfo.indices.at(i).first == expectedIndices.at(i).first);
+        NS_TEST_ASSERT_MSG_EQ(bandInfo.indices.at(i).first,
+                              expectedIndices.at(i).first,
+                              "Incorrect start indice for segment " << i);
+        NS_TEST_ASSERT_MSG_EQ(bandInfo.indices.at(i).second,
+                              expectedIndices.at(i).second,
+                              "Incorrect stop indice for segment " << i);
+        NS_TEST_ASSERT_MSG_EQ(bandInfo.frequencies.at(i).first,
+                              expectedFrequencies.at(i).first,
+                              "Incorrect start frequency for segment " << i);
+        NS_TEST_ASSERT_MSG_EQ(bandInfo.frequencies.at(i).second,
+                              expectedFrequencies.at(i).second,
+                              "Incorrect stop frequency for segment " << i);
+    }
+}
+
+void
+SpectrumWifiPhyGetBandTest::DoRun()
+{
+    const uint32_t indicesPer20MhzBand = 256; // based on 802.11ax carrier spacing
+    const MHz_u channelWidth = 160;           // we consider the largest channel width
+    const uint8_t channelNumberContiguous160Mhz =
+        50; // channel number of the first 160 MHz band in 5 GHz band
+    const std::vector<uint8_t> channelNumberPerSegment = {42,
+                                                          106}; // channel numbers used for 80+80MHz
+    // separation between segment at channel number 42 and segment at channel number 106
+    const MHz_u separationWidth = 240;
+    for (bool contiguous160Mhz : {true /* 160 MHz */, false /* 80+80MHz */})
+    {
+        MHz_u guardWidth = contiguous160Mhz ? channelWidth : (channelWidth / 2);
+        uint32_t guardStopIndice = (indicesPer20MhzBand * (guardWidth / 20)) - 1;
+        std::vector<WifiSpectrumBandIndices> previousExpectedIndices{};
+        std::vector<WifiSpectrumBandFrequencies> previousExpectedFrequencies{};
+        for (auto bandWidth : {20, 40, 80, 160})
+        {
+            const uint32_t expectedStartIndice = guardStopIndice + 1;
+            const uint32_t expectedStopIndice =
+                expectedStartIndice + (indicesPer20MhzBand * (bandWidth / 20)) - 1;
+            std::vector<WifiSpectrumBandIndices> expectedIndices{
+                {expectedStartIndice, expectedStopIndice}};
+            const Hz_u expectedStartFrequency = 5170 * 1e6;
+            const Hz_u expectedStopFrequency = (5170 + bandWidth) * 1e6;
+            std::vector<WifiSpectrumBandFrequencies> expectedFrequencies{
+                {expectedStartFrequency, expectedStopFrequency}};
+            const std::size_t numBands = (channelWidth / bandWidth);
+            for (std::size_t i = 0; i < numBands; ++i)
+            {
+                if ((bandWidth != channelWidth) && (i >= (numBands / 2)))
+                {
+                    // skip DC
+                    expectedIndices.at(0).first++;
+                }
+                if ((bandWidth == channelWidth) && !contiguous160Mhz)
+                {
+                    // For contiguous 160 MHz, band is made of the two 80 MHz segments (previous run
+                    // in the loop)
+                    expectedIndices = previousExpectedIndices;
+                    expectedFrequencies = previousExpectedFrequencies;
+                }
+                else if ((i == (numBands / 2)) && !contiguous160Mhz)
+                {
+                    expectedIndices.at(0).first += (indicesPer20MhzBand * (separationWidth / 20));
+                    expectedIndices.at(0).second += (indicesPer20MhzBand * (separationWidth / 20));
+                    expectedFrequencies.at(0).first += (separationWidth * 1e6);
+                    expectedFrequencies.at(0).second += (separationWidth * 1e6);
+                }
+                RunOne(contiguous160Mhz ? std::vector<uint8_t>{channelNumberContiguous160Mhz}
+                                        : channelNumberPerSegment,
+                       bandWidth,
+                       i,
+                       expectedIndices,
+                       expectedFrequencies);
+                if (!contiguous160Mhz && (bandWidth == (channelWidth / 2)))
+                {
+                    previousExpectedIndices.emplace_back(expectedIndices.front());
+                    previousExpectedFrequencies.emplace_back(expectedFrequencies.front());
+                }
+                expectedIndices.at(0).first = expectedIndices.at(0).second + 1;
+                expectedIndices.at(0).second =
+                    expectedIndices.at(0).first + (indicesPer20MhzBand * (bandWidth / 20)) - 1;
+                expectedFrequencies.at(0).first += (bandWidth * 1e6);
+                expectedFrequencies.at(0).second += (bandWidth * 1e6);
+            }
+        }
+    }
+
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Test tracked bands in interference helper upon channel switching
+ *
+ * The test is verifying that the correct bands are tracked by the interference helper upon channel
+ * switching. It focuses on 80 and 160 MHz bands while considering 160 MHz operating channels, for
+ * both contiguous and non-contiguous cases.
+ */
+class SpectrumWifiPhyTrackedBandsTest : public TestCase
+{
+  public:
+    SpectrumWifiPhyTrackedBandsTest();
+
+  private:
+    void DoSetup() override;
+    void DoTeardown() override;
+    void DoRun() override;
+
+    /**
+     * Switch channel function
+     *
+     * \param channelNumberPerSegment the channel number for each segment of the operating channel
+     * to switch to
+     */
+    void SwitchChannel(const std::vector<uint8_t>& channelNumberPerSegment);
+
+    /**
+     * Verify the bands tracked by the interference helper
+     *
+     * \param expectedTrackedBands the bands that are expected to be tracked by the interference
+     * helper
+     * \param expectedUntrackedBands the bands that are expected to be untracked by the
+     * interference helper
+     */
+    void VerifyTrackedBands(
+        const std::vector<std::vector<WifiSpectrumBandFrequencies>>& expectedTrackedBands,
+        const std::vector<std::vector<WifiSpectrumBandFrequencies>>& expectedUntrackedBands);
+
+    /**
+     * Run one function
+     * \param channelNumberPerSegmentBeforeSwitching the channel number for each segment of the
+     * operating channel to switch from \param channelNumberPerSegmentAfterSwitching the channel
+     * number for each segment of the operating channel to switch to \param expectedTrackedBands the
+     * bands that are expected to be tracked by the interference helper \param expectedUntrackedBand
+     * the bands that are expected to be untracked by the interference helper
+     */
+    void RunOne(const std::vector<uint8_t>& channelNumberPerSegmentBeforeSwitching,
+                const std::vector<uint8_t>& channelNumberPerSegmentAfterSwitching,
+                const std::vector<std::vector<WifiSpectrumBandFrequencies>>& expectedTrackedBands,
+                const std::vector<std::vector<WifiSpectrumBandFrequencies>>& expectedUntrackedBand);
+
+    Ptr<ExtSpectrumWifiPhy> m_phy; ///< PHY
+};
+
+SpectrumWifiPhyTrackedBandsTest::SpectrumWifiPhyTrackedBandsTest()
+    : TestCase("SpectrumWifiPhy test channel switching for non-contiguous operating channels")
+{
+}
+
+void
+SpectrumWifiPhyTrackedBandsTest::DoSetup()
+{
+    // WifiHelper::EnableLogComponents();
+    // LogComponentEnable("SpectrumWifiPhyTest", LOG_LEVEL_ALL);
+
+    auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+    auto lossModel = CreateObject<FriisPropagationLossModel>();
+    lossModel->SetFrequency(5.180e9);
+    spectrumChannel->AddPropagationLossModel(lossModel);
+    auto delayModel = CreateObject<ConstantSpeedPropagationDelayModel>();
+    spectrumChannel->SetPropagationDelayModel(delayModel);
+
+    auto node = CreateObject<Node>();
+    auto dev = CreateObject<WifiNetDevice>();
+    m_phy = CreateObject<ExtSpectrumWifiPhy>();
+    auto interferenceHelper = CreateObject<ExtInterferenceHelper>();
+    m_phy->SetInterferenceHelper(interferenceHelper);
+    auto errorModel = CreateObject<NistErrorRateModel>();
+    m_phy->SetErrorRateModel(errorModel);
+    m_phy->SetDevice(dev);
+    m_phy->AddChannel(spectrumChannel);
+    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
+    dev->SetPhy(m_phy);
+    node->AddDevice(dev);
+}
+
+void
+SpectrumWifiPhyTrackedBandsTest::DoTeardown()
+{
+    m_phy->Dispose();
+    m_phy = nullptr;
+}
+
+void
+SpectrumWifiPhyTrackedBandsTest::SwitchChannel(const std::vector<uint8_t>& channelNumberPerSegment)
+{
+    NS_LOG_FUNCTION(this);
+    WifiPhy::ChannelSegments channelSegments;
+    for (auto channelNumber : channelNumberPerSegment)
+    {
+        const auto& channelInfo = WifiPhyOperatingChannel::FindFirst(channelNumber,
+                                                                     0,
+                                                                     0,
+                                                                     WIFI_STANDARD_80211ax,
+                                                                     WIFI_PHY_BAND_5GHZ);
+        channelSegments.emplace_back(channelInfo->number, channelInfo->width, channelInfo->band, 0);
+    }
+    m_phy->SetOperatingChannel(channelSegments);
+}
+
+void
+SpectrumWifiPhyTrackedBandsTest::VerifyTrackedBands(
+    const std::vector<std::vector<WifiSpectrumBandFrequencies>>& expectedTrackedBands,
+    const std::vector<std::vector<WifiSpectrumBandFrequencies>>& expectedUntrackedBands)
+{
+    NS_LOG_FUNCTION(this);
+    PointerValue ptr;
+    m_phy->GetAttribute("InterferenceHelper", ptr);
+    auto interferenceHelper = DynamicCast<ExtInterferenceHelper>(ptr.Get<ExtInterferenceHelper>());
+    NS_ASSERT(interferenceHelper);
+    auto printBand = [](const std::vector<WifiSpectrumBandFrequencies>& v) {
+        std::stringstream ss;
+        for (const auto& [start, stop] : v)
+        {
+            ss << "[" << start << "-" << stop << "] ";
+        }
+        return ss.str();
+    };
+    for (const auto& expectedTrackedBand : expectedTrackedBands)
+    {
+        auto bandTracked = interferenceHelper->IsBandTracked(expectedTrackedBand);
+        NS_TEST_ASSERT_MSG_EQ(bandTracked,
+                              true,
+                              "Band " << printBand(expectedTrackedBand) << " is not tracked");
+    }
+    for (const auto& expectedUntrackedBand : expectedUntrackedBands)
+    {
+        auto bandTracked = interferenceHelper->IsBandTracked(expectedUntrackedBand);
+        NS_TEST_ASSERT_MSG_EQ(bandTracked,
+                              false,
+                              "Band " << printBand(expectedUntrackedBand)
+                                      << " is unexpectedly tracked");
+    }
+}
+
+void
+SpectrumWifiPhyTrackedBandsTest::RunOne(
+    const std::vector<uint8_t>& channelNumberPerSegmentBeforeSwitching,
+    const std::vector<uint8_t>& channelNumberPerSegmentAfterSwitching,
+    const std::vector<std::vector<WifiSpectrumBandFrequencies>>& expectedTrackedBands,
+    const std::vector<std::vector<WifiSpectrumBandFrequencies>>& expectedUntrackedBands)
+{
+    NS_LOG_FUNCTION(this);
+
+    Simulator::Schedule(Seconds(0),
+                        &SpectrumWifiPhyTrackedBandsTest::SwitchChannel,
+                        this,
+                        channelNumberPerSegmentBeforeSwitching);
+
+    Simulator::Schedule(Seconds(1),
+                        &SpectrumWifiPhyTrackedBandsTest::SwitchChannel,
+                        this,
+                        channelNumberPerSegmentAfterSwitching);
+
+    Simulator::Schedule(Seconds(2),
+                        &SpectrumWifiPhyTrackedBandsTest::VerifyTrackedBands,
+                        this,
+                        expectedTrackedBands,
+                        expectedUntrackedBands);
+
+    Simulator::Run();
+}
+
+void
+SpectrumWifiPhyTrackedBandsTest::DoRun()
+{
+    // switch from 160 MHz to 80+80 MHz
+    RunOne({50},
+           {42, 106},
+           {{{5170 * 1e6, 5250 * 1e6}} /* first 80 MHz segment */,
+            {{5490 * 1e6, 5570 * 1e6}} /* second 80 MHz segment */,
+            {{5170 * 1e6, 5250 * 1e6},
+             {5490 * 1e6, 5570 * 1e6}} /* non-contiguous 160 MHz band made of the two segments */},
+           {{{5170 * 1e6, 5330 * 1e6}} /* full 160 MHz band should have been removed */});
+
+    // switch from 80+80 MHz to 160 MHz
+    RunOne({42, 106},
+           {50},
+           {{{5170 * 1e6, 5330 * 1e6}} /* full 160 MHz band */,
+            {{5170 * 1e6, 5250 * 1e6}} /* first 80 MHz segment is part of the 160 MHz channel*/},
+           {{{5490 * 1e6, 5570 * 1e6}} /* second 80 MHz segment should have been removed */,
+            {{5170 * 1e6, 5250 * 1e6},
+             {5490 * 1e6, 5570 * 1e6}} /* non-contiguous 160 MHz band should have been removed */});
+
+    // switch from 80+80 MHz to 80+80 MHz with segment swap
+    RunOne({42, 106},
+           {106, 42},
+           {{{5490 * 1e6, 5570 * 1e6}} /* first 80 MHz segment */,
+            {{5490 * 1e6, 5570 * 1e6}} /* second 80 MHz segment */,
+            {{5170 * 1e6, 5250 * 1e6},
+             {5490 * 1e6, 5570 * 1e6}} /* non-contiguous 160 MHz band made of the two segments */},
+           {});
+
+    // switch from 80+80 MHz to another 80+80 MHz with one common segment
+    RunOne({42, 106},
+           {106, 138},
+           {{{5490 * 1e6, 5570 * 1e6}} /* first 80 MHz segment */,
+            {{5650 * 1e6, 5730 * 1e6}} /* second 80 MHz segment */,
+            {{5490 * 1e6, 5570 * 1e6},
+             {5650 * 1e6, 5730 * 1e6}} /* non-contiguous 160 MHz band made of the two segments */},
+           {{{5170 * 1e6, 5250 * 1e6}} /* 80 MHz segment at channel 42 should have been removed */,
+            {{5170 * 1e6, 5250 * 1e6},
+             {5490 * 1e6,
+              5570 * 1e6}} /* previous non-contiguous 160 MHz band should have been removed */});
+
+    // switch from 80+80 MHz to another 80+80 MHz with no common segment
+    RunOne(
+        {42, 106},
+        {122, 155},
+        {{{5570 * 1e6, 5650 * 1e6}} /* first 80 MHz segment */,
+         {{5735 * 1e6, 5815 * 1e6}} /* second 80 MHz segment */,
+         {{5570 * 1e6, 5650 * 1e6},
+          {5735 * 1e6, 5815 * 1e6}} /* non-contiguous 160 MHz band made of the two segments */},
+        {{{5170 * 1e6, 5250 * 1e6}} /* previous first 80 MHz segment should have been removed */,
+         {{5490 * 1e6, 5570 * 1e6}} /* previous second 80 MHz segment should have been removed */,
+         {{5170 * 1e6, 5250 * 1e6},
+          {5490 * 1e6,
+           5570 * 1e6}} /* previous non-contiguous 160 MHz band should have been removed */});
+
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Test 80+80MHz transmission
+ *
+ * The test verifies that two non-contiguous segments are handled by the spectrum PHY
+ * to transmit 160 MHz PPDUs when the operating channel is configured as 80+80MHz.
+ *
+ * The test first considers a contiguous 160 MHz segment and generate interference on the second
+ * 80 MHz band to verify reception fails in this scenario. Then, a similar interference
+ * is generated when a 80+80MHz operating channel is configured, where the first frequency segment
+ * occupies the first 80 MHz band of the previous 160 MHz operating channel. The reception should
+ * succeed in that scenario, which demonstrates the second 80 MHz band of the operating channel is
+ * no longer occupying that spectrum portion (the interference is hence is the gap between the two
+ * frequency segments). Finally, the test also generates interference on each of the frequency
+ * segments when the operating channel is 80+80MHz, to demonstrate the frequency segments are
+ * positioned as expected.
+ */
+class SpectrumWifiPhy80Plus80Test : public TestCase
+{
+  public:
+    SpectrumWifiPhy80Plus80Test();
+
+  private:
+    void DoSetup() override;
+    void DoTeardown() override;
+    void DoRun() override;
+
+    /**
+     * Run one function
+     * \param channelNumbers the channel number for each segment of the operating channel
+     * \param interferenceCenterFrequency the center frequency of the interference signal to
+     * generate
+     * \param interferenceBandWidth the band width of the interference signal to generate
+     * \param expectSuccess flag to indicate whether reception is expected to be successful
+     */
+    void RunOne(const std::vector<uint8_t>& channelNumbers,
+                MHz_u interferenceCenterFrequency,
+                MHz_u interferenceBandWidth,
+                bool expectSuccess);
+
+    /**
+     * Switch channel function
+     *
+     * \param channelNumbers the channel number for each segment of the operating channel
+     * to switch to
+     */
+    void SwitchChannel(const std::vector<uint8_t>& channelNumbers);
+
+    /**
+     * Send 160MHz PPDU function
+     */
+    void Send160MhzPpdu();
+
+    /**
+     * Generate interference function
+     * \param interferencePsd the PSD of the interference to be generated
+     * \param duration the duration of the interference
+     */
+    void GenerateInterference(Ptr<SpectrumValue> interferencePsd, Time duration);
+
+    /**
+     * Stop interference function
+     */
+    void StopInterference();
+
+    /**
+     * Receive success function for STA
+     * \param psdu the PSDU
+     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * \param txVector the transmit vector
+     * \param statusPerMpdu reception status per MPDU
+     */
+    void RxSuccessSta(Ptr<const WifiPsdu> psdu,
+                      RxSignalInfo rxSignalInfo,
+                      WifiTxVector txVector,
+                      std::vector<bool> statusPerMpdu);
+
+    /**
+     * Receive failure function for STA
+     * \param psdu the PSDU
+     */
+    void RxFailureSta(Ptr<const WifiPsdu> psdu);
+
+    /**
+     * Verify results
+     *
+     * \param expectSuccess flag to indicate whether reception is expected to be successful
+     */
+    void CheckResults(bool expectSuccess);
+
+    Ptr<SpectrumWifiPhy> m_phyAp;           ///< PHY of AP
+    Ptr<SpectrumWifiPhy> m_phySta;          ///< PHY of STA
+    Ptr<WaveformGenerator> m_phyInterferer; ///< PHY of interferer
+
+    uint32_t m_countRxSuccessSta; ///< count RX success for STA
+    uint32_t m_countRxFailureSta; ///< count RX failure for STA
+};
+
+SpectrumWifiPhy80Plus80Test::SpectrumWifiPhy80Plus80Test()
+    : TestCase("SpectrumWifiPhy test 80+80MHz transmission"),
+      m_countRxSuccessSta(0),
+      m_countRxFailureSta(0)
+{
+}
+
+void
+SpectrumWifiPhy80Plus80Test::SwitchChannel(const std::vector<uint8_t>& channelNumbers)
+{
+    NS_LOG_FUNCTION(this);
+    WifiPhy::ChannelSegments channelSegments;
+    for (auto channelNumber : channelNumbers)
+    {
+        const auto& channelInfo = WifiPhyOperatingChannel::FindFirst(channelNumber,
+                                                                     0,
+                                                                     0,
+                                                                     WIFI_STANDARD_80211ax,
+                                                                     WIFI_PHY_BAND_5GHZ);
+        channelSegments.emplace_back(channelInfo->number, channelInfo->width, channelInfo->band, 0);
+    }
+    m_phyAp->SetOperatingChannel(channelSegments);
+    m_phySta->SetOperatingChannel(channelSegments);
+}
+
+void
+SpectrumWifiPhy80Plus80Test::Send160MhzPpdu()
+{
+    NS_LOG_FUNCTION(this);
+
+    WifiTxVector txVector{HePhy::GetHeMcs7(),
+                          0,
+                          WIFI_PREAMBLE_HE_SU,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          160,
+                          false,
+                          false,
+                          false};
+
+    auto pkt = Create<Packet>(1000);
+    WifiMacHeader hdr;
+    hdr.SetType(WIFI_MAC_QOSDATA);
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
+
+    m_phyAp->Send(psdu, txVector);
+}
+
+void
+SpectrumWifiPhy80Plus80Test::GenerateInterference(Ptr<SpectrumValue> interferencePsd, Time duration)
+{
+    m_phyInterferer->SetTxPowerSpectralDensity(interferencePsd);
+    m_phyInterferer->SetPeriod(duration);
+    m_phyInterferer->Start();
+    Simulator::Schedule(duration, &SpectrumWifiPhy80Plus80Test::StopInterference, this);
+}
+
+void
+SpectrumWifiPhy80Plus80Test::StopInterference()
+{
+    m_phyInterferer->Stop();
+}
+
+void
+SpectrumWifiPhy80Plus80Test::RxSuccessSta(Ptr<const WifiPsdu> psdu,
+                                          RxSignalInfo rxSignalInfo,
+                                          WifiTxVector txVector,
+                                          std::vector<bool> /*statusPerMpdu*/)
+{
+    NS_LOG_FUNCTION(this << *psdu << rxSignalInfo << txVector);
+    m_countRxSuccessSta++;
+}
+
+void
+SpectrumWifiPhy80Plus80Test::RxFailureSta(Ptr<const WifiPsdu> psdu)
+{
+    NS_LOG_FUNCTION(this << *psdu);
+    m_countRxFailureSta++;
+}
+
+void
+SpectrumWifiPhy80Plus80Test::CheckResults(bool expectSuccess)
+{
+    NS_LOG_FUNCTION(this << expectSuccess);
+    NS_TEST_ASSERT_MSG_EQ(((m_countRxSuccessSta > 0) && (m_countRxFailureSta == 0)),
+                          expectSuccess,
+                          "Reception should be "
+                              << (expectSuccess ? "successful" : "unsuccessful"));
+}
+
+void
+SpectrumWifiPhy80Plus80Test::DoSetup()
+{
+    // WifiHelper::EnableLogComponents();
+    // LogComponentEnable("SpectrumWifiPhyTest", LOG_LEVEL_ALL);
+
+    auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+    auto lossModel = CreateObject<FriisPropagationLossModel>();
+    spectrumChannel->AddPropagationLossModel(lossModel);
+    auto delayModel = CreateObject<ConstantSpeedPropagationDelayModel>();
+    spectrumChannel->SetPropagationDelayModel(delayModel);
+
+    auto apNode = CreateObject<Node>();
+    auto apDev = CreateObject<WifiNetDevice>();
+    m_phyAp = CreateObject<SpectrumWifiPhy>();
+    auto apInterferenceHelper = CreateObject<InterferenceHelper>();
+    m_phyAp->SetInterferenceHelper(apInterferenceHelper);
+    auto apErrorModel = CreateObject<NistErrorRateModel>();
+    m_phyAp->SetErrorRateModel(apErrorModel);
+    m_phyAp->SetDevice(apDev);
+    m_phyAp->AddChannel(spectrumChannel);
+    m_phyAp->ConfigureStandard(WIFI_STANDARD_80211ax);
+    auto apMobility = CreateObject<ConstantPositionMobilityModel>();
+    m_phyAp->SetMobility(apMobility);
+    apDev->SetPhy(m_phyAp);
+    apNode->AggregateObject(apMobility);
+    apNode->AddDevice(apDev);
+
+    auto staNode = CreateObject<Node>();
+    auto staDev = CreateObject<WifiNetDevice>();
+    m_phySta = CreateObject<SpectrumWifiPhy>();
+    auto staInterferenceHelper = CreateObject<InterferenceHelper>();
+    m_phySta->SetInterferenceHelper(staInterferenceHelper);
+    auto staErrorModel = CreateObject<NistErrorRateModel>();
+    m_phySta->SetErrorRateModel(staErrorModel);
+    m_phySta->SetDevice(staDev);
+    m_phySta->AddChannel(spectrumChannel);
+    m_phySta->ConfigureStandard(WIFI_STANDARD_80211ax);
+    m_phySta->SetReceiveOkCallback(MakeCallback(&SpectrumWifiPhy80Plus80Test::RxSuccessSta, this));
+    m_phySta->SetReceiveErrorCallback(
+        MakeCallback(&SpectrumWifiPhy80Plus80Test::RxFailureSta, this));
+    auto staMobility = CreateObject<ConstantPositionMobilityModel>();
+    m_phySta->SetMobility(staMobility);
+    staDev->SetPhy(m_phySta);
+    staNode->AggregateObject(staMobility);
+    staNode->AddDevice(staDev);
+
+    auto interfererNode = CreateObject<Node>();
+    auto interfererDev = CreateObject<NonCommunicatingNetDevice>();
+    m_phyInterferer = CreateObject<WaveformGenerator>();
+    m_phyInterferer->SetDevice(interfererDev);
+    m_phyInterferer->SetChannel(spectrumChannel);
+    m_phyInterferer->SetDutyCycle(1);
+    interfererNode->AddDevice(interfererDev);
+}
+
+void
+SpectrumWifiPhy80Plus80Test::DoTeardown()
+{
+    m_phyAp->Dispose();
+    m_phyAp = nullptr;
+    m_phySta->Dispose();
+    m_phySta = nullptr;
+    m_phyInterferer->Dispose();
+    m_phyInterferer = nullptr;
+}
+
+void
+SpectrumWifiPhy80Plus80Test::RunOne(const std::vector<uint8_t>& channelNumbers,
+                                    MHz_u interferenceCenterFrequency,
+                                    MHz_u interferenceBandWidth,
+                                    bool expectSuccess)
+{
+    // reset counters
+    m_countRxSuccessSta = 0;
+    m_countRxFailureSta = 0;
+
+    Simulator::Schedule(Seconds(0),
+                        &SpectrumWifiPhy80Plus80Test::SwitchChannel,
+                        this,
+                        channelNumbers);
+
+    // create info about interference to generate
+    BandInfo bandInfo{.fl = (interferenceCenterFrequency - (interferenceBandWidth / 2)) * 1e6,
+                      .fc = interferenceCenterFrequency * 1e6,
+                      .fh = (interferenceCenterFrequency + (interferenceBandWidth / 2)) * 1e6};
+    auto spectrumInterference = Create<SpectrumModel>(Bands{bandInfo});
+    auto interferencePsd = Create<SpectrumValue>(spectrumInterference);
+    Watt_u interferencePower{0.1};
+    *interferencePsd = interferencePower / (interferenceBandWidth * 20e6);
+
+    Simulator::Schedule(Seconds(1),
+                        &SpectrumWifiPhy80Plus80Test::GenerateInterference,
+                        this,
+                        interferencePsd,
+                        MilliSeconds(100));
+
+    Simulator::Schedule(Seconds(1), &SpectrumWifiPhy80Plus80Test::Send160MhzPpdu, this);
+
+    Simulator::Schedule(Seconds(2),
+                        &SpectrumWifiPhy80Plus80Test::CheckResults,
+                        this,
+                        expectSuccess);
+
+    Simulator::Run();
+}
+
+void
+SpectrumWifiPhy80Plus80Test::DoRun()
+{
+    // Test transmission over contiguous 160 MHz (channel 50) and interference generated in
+    // the second half of the channel width (channel 58, i.e. center frequency 5290 and bandwidth 80
+    // MHz). The reception should fail because the interference occupies half the channel width used
+    // for the transmission.
+    //                                       ┌──────────────────┐
+    // Interference                          │    channel 58    │
+    //                                       │ 5290 MHz, 80 MHz │
+    //                                       └──────────────────┘
+    //
+    //                   ┌──────────────────────────────────────┐
+    // Operating Channel │             channel 50               │
+    //                   │          5250 MHz, 160 MHz           │
+    //                   └──────────────────────────────────────┘
+    //
+    RunOne({50}, 5290, 80, false);
+
+    // Test transmission over non-contiguous 160 MHz (i.e. 80+80MHz) and same interference as in
+    // previous run. The reception should succeed because the interference is located between the
+    // two segments.
+    //                                       ┌──────────────────┐
+    // Interference                          │    channel 58    │
+    //                                       │ 5290 MHz, 80 MHz │
+    //                                       └──────────────────┘
+    //
+    //                   ┌──────────────────┐                             ┌──────────────────┐
+    // Operating Channel │    channel 42    │                             │   channel 106    │
+    //                   │80+80MHz segment 0│                             │80+80MHz segment 1│
+    //                   └──────────────────┘                             └──────────────────┘
+    //
+    RunOne({42, 106}, 5290, 80, true);
+
+    // Test transmission over non-contiguous 160 MHz (i.e. 80+80MHz) and interference generated on
+    // the first segment of the channel width (channel 42, i.e. center frequency 5210 and bandwidth
+    // 80 MHz). The reception should fail because the interference occupies half the channel width
+    // used for the transmission.
+    //                   ┌──────────────────┐
+    // Interference      │    channel 42    │
+    //                   │ 5210 MHz, 80 MHz │
+    //                   └──────────────────┘
+    //
+    //                   ┌──────────────────┐                             ┌──────────────────┐
+    // Operating Channel │    channel 42    │                             │   channel 106    │
+    //                   │80+80MHz segment 0│                             │80+80MHz segment 1│
+    //                   └──────────────────┘                             └──────────────────┘
+    //
+    RunOne({42, 106}, 5210, 80, false);
+
+    // Test transmission over non-contiguous 160 MHz (i.e. 80+80MHz) and interference generated on
+    // the second segment of the channel width (channel 42, i.e. center frequency 5210 and bandwidth
+    // 80 MHz). The reception should fail because the interference occupies half the channel width
+    // used for the transmission.
+    //                                                                    ┌──────────────────┐
+    // Interference                                                       │    channel 106    │
+    //                                                                    │ 5530 MHz, 80 MHz │
+    //                                                                    └──────────────────┘
+    //
+    //                   ┌──────────────────┐                             ┌──────────────────┐
+    // Operating Channel │    channel 42    │                             │   channel 106    │
+    //                   │80+80MHz segment 0│                             │80+80MHz segment 1│
+    //                   └──────────────────┘                             └──────────────────┘
+    //
+    RunOne({42, 106}, 5530, 80, false);
+
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * \brief Spectrum Wifi Phy Multiple Spectrum Test
  *
  * This test is testing the ability to plug multiple spectrum channels to the spectrum wifi PHY.
